diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index 72b392279..d63ef9602 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -18,12 +18,7 @@ import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.item.block.ItemBlockAlgae;
-import net.minecraft.core.item.block.ItemBlockLadder;
-import net.minecraft.core.item.block.ItemBlockPainted;
-import net.minecraft.core.item.block.ItemBlockStairsPainted;
-import net.minecraft.core.item.block.ItemBlockLamp;
-import net.minecraft.core.item.block.ItemBlockSlabPainted;
+import net.minecraft.core.item.block.*;
 import net.minecraft.core.sound.BlockSounds;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.Dimension;
@@ -117,7 +112,7 @@ public final class Blocks {
         .withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
-    public static final Block<?> SANDSTONE = register("sandstone", "minecraft:block/sandstone", 30, (b) -> new BlockLogic(b, Material.stone))
+    public static final Block<?> SANDSTONE = register("sandstone", "minecraft:block/sandstone", 30, (b) -> new BlockLogicSandstone(b, Material.stone))
         .withSound(BlockSounds.STONE).withHardness(0.8F).withOverrideColor(MaterialColor.sand)
         .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_PICKAXE);
 
@@ -174,7 +169,7 @@ public final class Blocks {
         .setBlockItem((b) -> new ItemBlockPainted<>(b, true))
         .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
 
-    public static final Block<?> BOOKSHELF_PLANKS_OAK = register("bookshelf.planks.oak", "minecraft:block/bookshelf_planks_oak", 100, (b) -> new BlockLogic(b, Material.wood))
+    public static final Block<?> BOOKSHELF_PLANKS_OAK = register("bookshelf.planks.oak", "minecraft:block/bookshelf_planks_oak", 100, (b) -> new BlockLogicBookshelf(b, Material.wood))
         .withSound(BlockSounds.WOOD).withHardness(1.5F)
         .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
 
@@ -577,10 +572,10 @@ public final class Blocks {
         .withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedOrange)
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.SHEEPS_FAVOURITE_BLOCK, BlockTags.SHEARS_DO_SILK_TOUCH);
 
-    public static final Block<?> MUSHROOM_BROWN = register("mushroom.brown", "minecraft:block/mushroom_brown", 340, BlockLogicMushroom::new)
+    public static final Block<?> MUSHROOM_BROWN = register("mushroom.brown", "minecraft:block/mushroom_brown", 340, (b) -> new BlockLogicMushroom(b).setBonemealable())
         .withSound(BlockSounds.GRASS).withHardness(0.0F).withLightEmission(0.125F).withOverrideColor(MaterialColor.paintedBrown)
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.PIGS_FAVOURITE_BLOCK);
-    public static final Block<?> MUSHROOM_RED = register("mushroom.red", "minecraft:block/mushroom_red", 341, BlockLogicMushroom::new)
+    public static final Block<?> MUSHROOM_RED = register("mushroom.red", "minecraft:block/mushroom_red", 341, (b) -> new BlockLogicMushroom(b).setBonemealable())
         .withSound(BlockSounds.GRASS).withHardness(0.0F).withOverrideColor(MaterialColor.paintedRed)
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR, BlockTags.PIGS_FAVOURITE_BLOCK);
 
@@ -758,13 +753,13 @@ public final class Blocks {
     public static final Block<?> BUTTON_STONE = register("button.stone", "minecraft:block/button_stone", 470, BlockLogicButton::new)
         .withSound(BlockSounds.STONE).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
-    public static final Block<?> BUTTON_PLANKS = register("button.planks", "minecraft:block/button_planks", 471, BlockLogicButton::new)
+    public static final Block<?> BUTTON_PLANKS = register("button.planks", "minecraft:block/button_planks", 471, BlockLogicButtonPlanks::new)
         .withSound(BlockSounds.WOOD).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_AXE, BlockTags.PREVENT_MOB_SPAWNS);
     public static final Block<BlockLogicButtonPainted> BUTTON_PLANKS_PAINTED = register("button.planks.painted", "minecraft:block/button_planks_painted", 472, BlockLogicButtonPainted::new)
         .setBlockItem((b) -> new ItemBlockPainted<>(b, true))
         .withSound(BlockSounds.WOOD).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
-        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.PREVENT_MOB_SPAWNS);
+        .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.MINEABLE_BY_AXE, BlockTags.PREVENT_MOB_SPAWNS);
 
     public static final Block<?> LEVER_COBBLE_STONE = register("lever.cobble.stone", "minecraft:block/lever_cobble_stone", 480, BlockLogicLever::new)
         .withSound(BlockSounds.STONE).withHardness(0.5F).withDisabledNeighborNotifyOnMetadataChange()
@@ -805,16 +800,23 @@ public final class Blocks {
         .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block<BlockLogicPistonHead> PISTON_HEAD = register("piston.head", "minecraft:block/piston_head", 522, (BlockLogicSupplier<BlockLogicPistonHead>)(b) -> new BlockLogicPistonHead(b, 4/16d, 4/16d))
-        .withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats().withImmovableFlagSet()
+        .withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats().withImmovableFlagSet()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block<BlockLogicPistonMoving> PISTON_MOVING = register("piston.moving", "minecraft:block/piston_moving", 523, BlockLogicPistonMoving::new)
         .withSound(BlockSounds.STONE).withDisabledStats()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU);
     public static final Block<BlockLogicPistonBase> PISTON_BASE_STEEL = register("piston.base.steel", "minecraft:block/piston_base_steel", 524, (BlockLogicSupplier<BlockLogicPistonBase>)b -> new BlockLogicPistonBaseSteel(b, 24))
-        .withSound(BlockSounds.METAL).withDisabledNeighborNotifyOnMetadataChange()
+        .withSound(BlockSounds.METAL)
+        .withHardness(5F)
+        .withBlastResistance(2000F)
+        .withOverrideColor(MaterialColor.steel).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final Block<BlockLogicPistonHead> PISTON_HEAD_STEEL = register("piston.head.steel", "minecraft:block/piston_head_steel", 525, (BlockLogicSupplier<BlockLogicPistonHead>)(b) -> new BlockLogicPistonHead(b, 6/16d, 8/16d))
-        .withSound(BlockSounds.METAL).withDisabledNeighborNotifyOnMetadataChange().withDisabledStats()
+        .withSound(BlockSounds.METAL)
+        .withHardness(5F)
+        .withBlastResistance(2000F)
+        .withOverrideColor(MaterialColor.steel)
+        .withDisabledNeighborNotifyOnMetadataChange().withDisabledStats()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
     public static final Block<?> NOTEBLOCK = register("noteblock", "minecraft:block/noteblock", 530, BlockLogicNote::new)
@@ -1006,11 +1008,11 @@ public final class Blocks {
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
 
     public static final Block<BlockLogicSignPainted> SIGN_POST_PLANKS_OAK_PAINTED = register("sign.post.planks.oak.painted", "minecraft:block/sign_post_planks_oak_painted", 713, (BlockLogicSupplier<BlockLogicSignPainted>)(b) -> new BlockLogicSignPainted(b, true))
-        .withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.SIGN)
-        .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
+            .withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> Items.SIGN)
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
     public static final Block<BlockLogicSignPainted> SIGN_WALL_PLANKS_OAK_PAINTED = register("sign.wall.planks.oak.painted", "minecraft:block/sign_wall_planks_oak_painted", 714, (BlockLogicSupplier<BlockLogicSignPainted>)(b) -> new BlockLogicSignPainted(b, false))
-        .withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> SIGN_POST_PLANKS_OAK)
-        .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
+            .withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange().setStatParent(() -> SIGN_POST_PLANKS_OAK)
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_AXE);
 
     public static final Block<BlockLogicLayerSnow> LAYER_SNOW = register("layer.snow", "minecraft:block/layer_snow", 720, (BlockLogicSupplier<BlockLogicLayerSnow>)(b) -> new BlockLogicLayerSnow(b, Blocks.BLOCK_SNOW, Material.topSnow))
         .withSound(BlockSounds.CLOTH).withHardness(0.1F).withLitInteriorSurface(true)
@@ -1190,7 +1192,7 @@ public final class Blocks {
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.CAN_HANG_OFF);
 
     public static final Block<BlockLogicBasket> BASKET = register("basket", "minecraft:block/basket", 900, (BlockLogicSupplier<BlockLogicBasket>)(b) -> new BlockLogicBasket(b, Material.cloth))
-        .withSound(BlockSounds.CLOTH).withHardness(0.5F).withOverrideColor(MaterialColor.wood).setStatParent(() -> Items.BASKET)
+        .withSound(BlockSounds.CLOTH).withHardness(0.5F).withOverrideColor(MaterialColor.wood).setStatParent(() -> Items.BASKET).withDisabledNeighborNotifyOnMetadataChange()
         .withTags(BlockTags.NOT_IN_CREATIVE_MENU);
 
     public static final Block<?> PAPER_WALL = register("paper_wall", "minecraft:block/paper_wall", 910, (b) -> new BlockLogic(b, Material.cloth))
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
index a6ea92d5a..c076eca63 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntity.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.block.entity;
 
 import com.mojang.nbt.tags.CompoundTag;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.motion.CarriedBlock;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
@@ -38,6 +39,12 @@ public abstract class TileEntity implements ICarriable
     {
         if(worldObj != null)
         {
+            int id = getBlockId();
+            if (id != 0 && Blocks.getBlock(id).isSignalSource()) {
+                for (Side s : Side.sides){
+                    worldObj.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), getBlockId());
+                }
+            }
             worldObj.updateTileEntityChunkAndSendToPlayer(x, y, z, this);
         }
     }
@@ -152,6 +159,11 @@ public abstract class TileEntity implements ICarriable
             b.onBlockPlacedByMob(world, x, y, z, side, (Mob) holder, xPlaced, yPlaced);
         }
         world.notifyBlockChange(x, y, z, carriedBlock.blockId);
+        if (carriedBlock.blockId != 0 && Blocks.getBlock(carriedBlock.blockId).isSignalSource()) {
+            for (Side s : Side.sides){
+                worldObj.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), getBlockId());
+            }
+        }
         return true;
     }
 
@@ -187,6 +199,12 @@ public abstract class TileEntity implements ICarriable
         world.removeBlockTileEntity(x, y, z);
         world.setBlockRaw(x, y, z, 0);
         world.notifyBlockChange(x, y, z, 0);
+        int id = getBlockId();
+        if (currentBlock.isSignalSource()) {
+            for (Side s : Side.sides){
+                worldObj.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), getBlockId());
+            }
+        }
         this.worldObj = null;
         this.carriedBlock = getCarriedEntry(world, holder, currentBlock, currentMeta);
         return carriedBlock;
diff --git a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
index f8c5c3073..ac116064d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/entity/TileEntityBasket.java
@@ -4,9 +4,13 @@ import java.util.*;
 
 import it.unimi.dsi.fastutil.objects.Object2IntArrayMap;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.motion.CarriedBlock;
+import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -14,7 +18,9 @@ import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.ListTag;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.net.packet.PacketTileEntityData;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.ICarriable;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 
@@ -23,24 +29,27 @@ public class TileEntityBasket extends TileEntity
     private int numUnitsInside = 0;
     private final Object2IntMap<BasketEntry> contents = new Object2IntArrayMap<>();
 
-
     private void updateNumUnits()
     {
-        final int prevNum = this.numUnitsInside;
-        this.numUnitsInside = 0;
+        int currentNumInside = calcNumUnitsInside();
+        if (currentNumInside != numUnitsInside && worldObj != null){
+            this.numUnitsInside = currentNumInside;
+            worldObj.notifyBlockChange(x, y, z, worldObj.getBlockId(x, y, z));
+            setChanged();
+        }
+    }
 
-        for (final Object2IntMap.Entry<BasketEntry> entry : this.contents.object2IntEntrySet())
+    private int calcNumUnitsInside() {
+        int numInside = 0;
+        for (Map.Entry<BasketEntry, Integer> entry : contents.object2IntEntrySet())
         {
             final BasketEntry be = entry.getKey();
-            final int numItems = entry.getIntValue();
+            final int numItems = entry.getValue();
 
-            final int unitsPerItem = getItemSizeUnits(be.getItem());
-            this.numUnitsInside += (unitsPerItem * numItems);
-        }
-        if (prevNum != numUnitsInside && worldObj != null){
-            worldObj.notifyBlockChange(x, y, z, worldObj.getBlockId(x, y, z));
-            setChanged();
+            int unitsPerItem = getItemSizeUnits(be.getItem());
+            numInside += (unitsPerItem * numItems);
         }
+        return numInside;
     }
 
     private int getItemSizeUnits(final Item item)
@@ -117,7 +126,7 @@ public class TileEntityBasket extends TileEntity
             final int count = itemTag.getShort("Count");
             this.contents.put(entry, count);
         }
-        updateNumUnits();
+        this.numUnitsInside = calcNumUnitsInside();
     }
 
     @Override
@@ -152,13 +161,12 @@ public class TileEntityBasket extends TileEntity
 
         if (!entities.isEmpty())
         {
-            for (final EntityItem e : entities)
-            {
-                if (e.item != null && e.item.stackSize > 0 && e.basketPickupDelay == 0)
-                {
+            for (int i = 0; i < entities.size(); i++) {
+                if (calcNumUnitsInside() >= getMaxUnits()) break;
+                EntityItem e = entities.get(i);
+                if (e.item != null && e.item.stackSize > 0 && e.basketPickupDelay == 0) {
                     shouldUpdate = importItemStack(e.item);
-                    if (e.item.stackSize <= 0)
-                    {
+                    if (e.item.stackSize <= 0) {
                         e.item.stackSize = 0;
                         e.outOfWorld();
                     }
@@ -177,9 +185,9 @@ public class TileEntityBasket extends TileEntity
 
     private boolean importItemStack(final ItemStack stack)
     {
-        final BasketEntry entry = new BasketEntry(stack.itemID, stack.getMetadata(), stack.getData());
+        BasketEntry entry = new BasketEntry(stack.itemID, stack.getMetadata(), stack.getData());
         final int sizeUnits = getItemSizeUnits(stack.getItem());
-        final int freeUnits = getMaxUnits() - this.numUnitsInside;
+        final int freeUnits = getMaxUnits() - numUnitsInside;
         final int itemsToTake = Math.min(freeUnits / sizeUnits, stack.stackSize);
         if (itemsToTake <= 0) return false;
         stack.stackSize -= itemsToTake;
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
index b24877e18..496c5a056 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonBaseSteel.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.block.piston;
 
+import net.minecraft.core.Global;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
@@ -7,6 +8,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityFallingBlock;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
@@ -196,7 +198,8 @@ public class BlockLogicPistonBaseSteel extends BlockLogicPistonBase {
     public void extendEvent(World world, int x, int y, int z, int data, Direction direction) {
         List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, AABB.getTemporaryBB((double)x + direction.getOffsetX(), (double)y + direction.getOffsetY(), (double)z + direction.getOffsetZ(), (double)x + direction.getOffsetX() + 1, (double)y + direction.getOffsetY() + 1, (double)z + direction.getOffsetZ() + 1)));
         for (Entity entity : entityList){
-            if (entity == null || entity.noPhysics || entity == flungBlock /*Fix for 1 tick extensions not working properly*/ ) continue;
+            if (entity == null || entity.noPhysics || entity == flungBlock /*Fix for 1 tick extensions not working properly*/
+                || (entity.world != null && entity.world.isClientSide && entity instanceof Player)) continue;
             final double speed = 2;
             entity.fling(direction.getOffsetX() * speed, direction.getOffsetY() * speed, direction.getOffsetZ() * speed, 1f);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index b88295fd0..fc928805f 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -62,6 +62,7 @@ public class Registries extends Registry<Registry<?>>
         RECIPE_TYPES.register("minecraft:crafting/uses_tool", RecipeEntryCraftingWithTool.class);
         RECIPE_TYPES.register("minecraft:crafting/map_duplication", RecipeEntryMapDuplication.class);
         RECIPE_TYPES.register("minecraft:crafting/undyeing", RecipeEntryUndyeing.class);
+        RECIPE_TYPES.register("minecraft:crafting/dyeing", RecipeEntryDyeing.class);
         RECIPE_TYPES.register("minecraft:smelting", RecipeEntryFurnace.class);
         RECIPE_TYPES.register("minecraft:smelting/blast", RecipeEntryBlastFurnace.class);
         RECIPE_TYPES.register("minecraft:trommeling", RecipeEntryTrommel.class);
@@ -96,6 +97,8 @@ public class Registries extends Registry<Registry<?>>
             List<ItemStack> invertedLampStackList = new ArrayList<>();
             List<ItemStack> woodenButtonsList = new ArrayList<>();
             List<ItemStack> woodenPressurePlatesList = new ArrayList<>();
+            List<ItemStack> buttonsList = new ArrayList<>();
+            List<ItemStack> pressurePlatesList = new ArrayList<>();
 
             plankStackList.add(Blocks.PLANKS_OAK.getDefaultStack());
             signStackList.add(Items.SIGN.getDefaultStack());
@@ -108,6 +111,9 @@ public class Registries extends Registry<Registry<?>>
             trapdoorStackList.add(Blocks.TRAPDOOR_PLANKS_OAK.getDefaultStack());
             woodenButtonsList.add(Blocks.BUTTON_PLANKS.getDefaultStack());
             woodenPressurePlatesList.add(Blocks.PRESSURE_PLATE_PLANKS_OAK.getDefaultStack());
+            buttonsList.add(Blocks.BUTTON_STONE.getDefaultStack());
+            pressurePlatesList.add(Blocks.PRESSURE_PLATE_STONE.getDefaultStack());
+            pressurePlatesList.add(Blocks.PRESSURE_PLATE_COBBLE_STONE.getDefaultStack());
 
             for (DyeColor color : DyeColor.values()) {
                 plankStackList.add(new ItemStack(Blocks.PLANKS_OAK_PAINTED, 1, color.blockMeta));
@@ -125,6 +131,10 @@ public class Registries extends Registry<Registry<?>>
                 woodenButtonsList.add(new ItemStack(Blocks.BUTTON_PLANKS_PAINTED, 1, color.blockMeta << 4));
                 woodenPressurePlatesList.add(new ItemStack(Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, 1, color.blockMeta << 4));
             }
+
+            buttonsList.addAll(woodenButtonsList);
+            pressurePlatesList.addAll(woodenPressurePlatesList);
+
             ITEM_GROUPS.register("minecraft:planks",plankStackList);
             ITEM_GROUPS.register("minecraft:signs",signStackList);
             ITEM_GROUPS.register("minecraft:doors",doorStackList);
@@ -139,6 +149,8 @@ public class Registries extends Registry<Registry<?>>
             ITEM_GROUPS.register("minecraft:trapdoor_planks", trapdoorStackList);
             ITEM_GROUPS.register("minecraft:button_planks", woodenButtonsList);
             ITEM_GROUPS.register("minecraft:pressureplates_planks", woodenPressurePlatesList);
+            ITEM_GROUPS.register("minecraft:buttons", buttonsList);
+            ITEM_GROUPS.register("minecraft:pressureplates", pressurePlatesList);
         }
 
         ITEM_GROUPS.register("minecraft:tool_swords",
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 6d0b22d96..9ce38edc6 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -71,6 +71,9 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
         if (obj.has("tag")) {
             tag = NbtIo.fromJson(obj.get("tag"));
         }
+        if (item == null) {
+            throw new JsonParseException("Could not parse stack for json:\n" + json);
+        }
         return new ItemStack(item, amount, meta, tag);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryDyeingJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryDyeingJsonAdapter.java
new file mode 100644
index 000000000..34e17d861
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/RecipeEntryDyeingJsonAdapter.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.data.registry.recipe.adapter;
+
+import com.google.gson.*;
+import net.minecraft.core.data.registry.Registries;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryDyeing;
+import net.minecraft.core.item.ItemStack;
+
+import java.lang.reflect.Type;
+
+public class RecipeEntryDyeingJsonAdapter implements RecipeJsonAdapter<RecipeEntryDyeing>{
+    @Override
+    public RecipeEntryDyeing deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
+        JsonObject obj = json.getAsJsonObject();
+        RecipeSymbol input = context.deserialize(obj.get("input"), RecipeSymbol.class);
+        ItemStack output = context.deserialize(obj.get("output"), ItemStack.class);
+        boolean useUpperMeta = false;
+        boolean useItemMeta = false;
+        if(obj.has("useUpperMeta")){
+            useUpperMeta = obj.get("useUpperMeta").getAsBoolean();
+        }
+        if(obj.has("useItemMeta")){
+            useItemMeta = obj.get("useItemMeta").getAsBoolean();
+        }
+        return new RecipeEntryDyeing(input, output, useUpperMeta, useItemMeta);
+    }
+
+    @Override
+    public JsonElement serialize(RecipeEntryDyeing src, Type typeOfSrc, JsonSerializationContext context) {
+        JsonObject object = new JsonObject();
+        object.addProperty("name",src.toString());
+        object.addProperty("type", Registries.RECIPE_TYPES.getKey(src.getClass()));
+        if(src.useUpperMeta){
+            object.addProperty("useUpperMeta", true);
+        }
+        if(src.useItemMeta){
+            object.addProperty("useItemMeta", true);
+        }
+
+        object.add("input", context.serialize(src.inputSymbol));
+        object.add("output", context.serialize(src.output));
+        return object;
+    }
+}
